<?php
/**
 * Error
 *
 * PHP version 5
 *
 * @category Class
 * @package  Com\Alacriti\Checkout\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay-Checkout APIs
 *
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Com\Alacriti\Checkout\Client\Model;

use \ArrayAccess;

/**
 * ResponseHeader Class Doc Comment
 *
 * @category    Class
 * @package     Com\Alacriti\Checkout\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ResponseHeader implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ResponseHeader';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'clientKey' => 'string',
        'requestUuid' => 'string',
        'requestTimestamp' => 'string',
        'responseCode' => 'string',
        'idempotentRequestKey' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'clientKey' => null,
        'requestUuid' => null,
        'requestTimestamp' => null,
        'responseCode' => null,
        'idempotentRequestKey' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'clientKey' => 'clientKey',
        'requestUuid' => 'requestUuid',
        'requestTimestamp' => 'requestTimestamp',
        'responseCode' => 'responseCode',
        'idempotentRequestKey' => 'idempotentRequestKey'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'clientKey' => 'setClientKey',
        'requestUuid' => 'setRequestUuid',
        'requestTimestamp' => 'setRequestTimestamp',
        'responseCode' => 'setResponseCode',
        'idempotentRequestKey' => 'setIdempotentRequestKey'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'clientKey' => 'getClientKey',
        'requestUuid' => 'getRequestUuid',
        'requestTimestamp' => 'getRequestTimestamp',
        'responseCode' => 'getResponseCode',
        'idempotentRequestKey' => 'getIdempotentRequestKey'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['clientKey'] = isset($data['clientKey']) ? $data['clientKey'] : null;
        $this->container['requestUuid'] = isset($data['requestUuid']) ? $data['requestUuid'] : null;
        $this->container['requestTimestamp'] = isset($data['requestTimestamp']) ? $data['requestTimestamp'] : null;
        $this->container['responseCode'] = isset($data['responseCode']) ? $data['responseCode'] : null;
        $this->container['idempotentRequestKey'] = isset($data['idempotentRequestKey']) ? $data['idempotentRequestKey'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['code'] === null) {
            $invalid_properties[] = "'code' can't be null";
        }
        if ($this->container['message'] === null) {
            $invalid_properties[] = "'message' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['code'] === null) {
            return false;
        }
        if ($this->container['message'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets clientKey
     * @return string
     */
    public function getClientKey()
    {
        return $this->container['clientKey'];
    }

    /**
     * Sets clientKey
     * @param string $clientKey
     * @return $this
     */
    public function setClientKey($clientKey)
    {
        $this->container['clientKey'] = $clientKey;

        return $this;
    }

    /**
     * Gets requestUuid
     * @return string
     */
    public function getRequestUuid()
    {
        return $this->container['requestUuid'];
    }

    /**
     * Sets requestUuid
     * @param string $requestUuid
     * @return $this
     */
    public function setRequestUuid($requestUuid)
    {
        $this->container['requestUuid'] = $requestUuid;
	echo "<script>console.log('requestUuid is: ".$requestUuid."');</script>";
        return $this;
    }

    /**
     * Gets requestTimestamp
     * @return string
     */
    public function getRequestTimestamp()
    {
        return $this->container['requestTimestamp'];
    }

    /**
     * Sets requestTimestamp
     * @param string $requestTimestamp
     * @return $this
     */
    public function setRequestTimestamp($requestTimestamp)
    {
        $this->container['requestTimestamp'] = $requestTimestamp;
    echo "<script>console.log('requestTimestamp is: ".$requestTimestamp."');</script>";
        return $this;
    }
        /**
     * Gets responseCode
     * @return string
     */
    public function getResponseCode()
    {
        return $this->container['responseCode'];
    }

    /**
     * Sets responseCode
     * @param string $responseCode
     * @return $this
     */
    public function setResponseCode($responseCode)
    {
        $this->container['responseCode'] = $responseCode;
    echo "<script>console.log('responseCode is: ".$responseCode."');</script>";
        return $this;
    }


    /**
     * Gets idempotentRequestKey
     * @return string
     */
    public function getIdempotentRequestKey()
    {
        return $this->container['idempotentRequestKey'];
    }

    /**
     * Sets idempotentRequestKey
     * @param string $idempotentRequestKey Name of the invalid parameter.
     * @return $this
     */
    public function setIdempotentRequestKey($idempotentRequestKey)
    {
        $this->container['idempotentRequestKey'] = $idempotentRequestKey;
        echo "<script>console.log('idempotentRequestKey is: ".$idempotentRequestKey."');</script>";

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Com\Alacriti\Checkout\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Com\Alacriti\Checkout\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}


